<?php
/**
* @version $Id: a_translator.php 2005-11-11 23:12:31 Angel Franco Calixto $
* @package Joombook
* @copyright Copyright (C) 2005 TodosJuntos!. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joombook! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

# Internacionalizacin (I18N)
class sjoomla_I18N {
/** @var boolean If true, highlights string not found */
	/** @var boolean If true, highlights string not found */
	var $_debug = false;
	/** @var string Official element name of the language */
	var $_name=null;
	/** @var string language locale for the locale formating */
	var $_locale=null;
	/** @var string iso charset of html files */
	var $_iso=null;
	/** @var string iso code of the languge */
	var $_isocode=null;
	/** @var boolean True if language is displayed right-to-left */
	var $_rtl=null;
	/** @var string The default language to load */
	var $_defaultLang=null;
	/** @var string The user language to load */
	var $_userLang=null;
	/** @var string The user language to load */
	var $_basedir=null;
	/** @var string Identifying string of the language */
	var $_identifyer=null;
	/** @var array Transaltions */
	var $_strings=null;
	
/*
  var $defaultlanguage = 'english';
  var $language = 'english';
  var $basedir = '';
	var $_identifyer=null;
*/
  function sjoomla_I18N() {
    global $mosConfig_absolute_path;
    $this->_basedir = $mosConfig_absolute_path.'/administrator/components/com_joombook/language/';
	$this->_strings = array();

		if( isset( $this->_locale ) ) {
			setlocale (LC_TIME, $this->_locale);
		}
		$this->_defaultLang = 'english';
	
    if (isset($_SESSION['adminlanguage']) && is_dir($this->_basedir.$_SESSION['adminlanguage']['iso'])) {
      $this->_userLang = $_SESSION['adminlanguage']['iso'];
    } else {
      print "Idioma no encontrado: ".$_SESSION['adminlanguage'];
      exit;
    }
  }

	/**
	* Translator function, mimics the php gettext (alias _) function
	*/
	function _( $string, $jsSafe=false ) {
		//$key = str_replace( ' ', '_', strtoupper( trim( $string ) ) );echo '<br>'.$key;
		$key = strtoupper( $string );
		$key = substr( $key, 0, 1) == '_' ? substr( $key, 1 ) : $key;
		if (isset( $this->_strings[$key] )) {
			$string = $this->_debug ? "&bull;".$this->_strings[$key]."&bull;" : $this->_strings[$key];
		} else {
			if( defined( $string ) ) {
				$string = $this->_debug ? "!!" .constant( $string ). "!!" : constant( $string );
			} else {
				$string = $this->_debug ? "??$string??" : $string;
			}
		}
		if ($jsSafe) {
			$string = str_replace( "\n", '\\n', $string );
			$string = str_replace( '"', '&quot;', $string );
			$string = str_replace( '\'', '&#39;', $string );
		}
		return $string;
	}

	/**
	 * Passes a string thru an sprintf
	 * @param format The format string
	 * @param mixed Mixed number of arguments for the sprintf function
	 */
	function sprintf( $string ) {
		$args = func_get_args();
		if (count( $args ) > 0) {
			$args[0] = $this->_( $args[0] );
			return call_user_func_array( 'sprintf', $args );
		}
		return '';
	}
	/**
	 * Passes a string thru an printf
	 * @param format The format string
	 * @param mixed Mixed number of arguments for the sprintf function
	 */
	function printf( $string ) {
		$args = func_get_args();
		if (count( $args ) > 0) {
			$args[0] = $this->_( $args[0] );
			return call_user_func_array( 'printf', $args );
		}
		return '';
	}

/**
	* Loads a language file and appends the results to the existing strings
	* @param string The name of the file
	* @return boolean True if successful, false is failed
	*/
	function _load( $filename ) {
	global $mosConfig_absolute_path;
		if (file_exists( $filename )) {
			if ($content = file_get_contents( $filename )) {
			
				if( $this->_identifyer === null ) {
					$this->_identifyer = basename( $filename, '.ini' );
				}
                include_once $mosConfig_absolute_path ."/includes/joomla.xml.php";
				$this->_strings = array_merge( $this->_strings, mosParameters::parse( $content, false, true ) );

				if (isset( $this->_strings['__NAME'] )) {
					$this->name( $this->_strings['__NAME'] );
				}
				if (isset( $this->_strings['__ISO'] )) {
					$this->iso( $this->_strings['__ISO'] );
				}
				if (isset( $this->_strings['__LOCALE'] )) {
					$this->locale( $this->_strings['__LOCALE'] );
				}
				if (isset( $this->_strings['__ISOCODE'] )) {
					$this->isoCode( $this->_strings['__ISOCODE'] );
				}
				if (isset( $this->_strings['__RTL'] )) {
					$this->rtl( $this->_strings['__RTL'] );
				}

				return true;
			}
		}
		return false;
	}

	/**
	 * Loads a single langauge file
	 * @param string The option
	 * @param mixed The client id: 0=site, 1=admin, 2=installation
	 */
	function load( $option='') {
		$basePath = $this->_basedir ;

		if (empty( $option )) {
			$filename = $basePath . $this->_userLang .'/'.$this->_userLang. '.ini';
			if (!file_exists( $filename ) ) {
				// roll back to default language
				$filename = $basePath . $this->_defaultLang .'/'.$this->_defaultLang. '.ini';
			}
		} else {
			$filename = $basePath . $this->_userLang .'/'.$this->_userLang. '.' . $option . '.ini';
			if (!file_exists( $filename ) ) {
				// roll back to default language
				$filename = $basePath . $this->_defaultLang .'/'.$this->_defaultLang. '.' . $option . '.ini';
			}
		}

		$this->_load( $filename );
	}

	/**
	 * Loads the main and component language files
	 * @param string The option
	 * @param mixed The client id: 0=site, 1=admin, 2=installation
	 */
	function loadAll( $option='') {
		// load primary language file
		$this->load( '' );

		// load 'option'(al) language file
		$option = trim( $option );
		if ($option) {
			$this->load( $option );
		}
	}

	/**
	* Getter for Name
	* @param string An optional value
	* @return string Official name element of the language
	*/
	function name( $value=null ) {
		return $value !== null ? $this->_name = $value : $this->_name;
	}

	/**
	* Getter for ISO
	* @param string An optional value
	* @return string ISO charset for the html files
	*/
	function iso( $value=null ) {
		return $value !== null ? $this->_iso = $value : $this->_iso;
	}

	/**
	* Getter for ISO code
	* @param string An optional value
	* @return string iso code of the languge
	*/
	function isoCode( $value=null ) {
		return $value !== null ? $this->_isocode = $value : $this->_isocode;
	}

	/**
	* Getter for Locale information of the language
	* @param string An optional value
	* @return string locale string
	*/
	function locale( $value=null ) {
		return $value !== null ? $this->_locale = $value : $this->_locale;
	}
	/**
	* Sets/gets the RTL property
	* @param string An optional value
	* @return string locale string
	*/
	function rtl( $value=null ) {
		return $value !== null ? $this->_rtl = $value : $this->_rtl;
	}
	/**
	* Sets/gets the Debug property
	* @param string An optional value
	* @return string locale string
	*/
	function debug( $value=null ) {
		return $value !== null ? $this->_debug = $value : $this->_debug;
	}

	/**
	 * Determines is a key exists
	 */
	function hasKey( $key ) {
		return isset( $this->_strings[strtoupper( $key )] );
	}

}
?>